﻿using Syncfusion.SfDataGrid.XForms;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Xamarin.Forms;

namespace TemplateDemo
{
    public class App : Application
    {
        SfDataGrid sfGrid;
        ViewModel vm;
        StackLayout layout;
        public App()
        {
            vm = new ViewModel();
            sfGrid = new SfDataGrid();
            sfGrid.ItemsSource = vm.OrdersInfo;
            sfGrid.AutoGenerateColumns = false;

            var column2 = new GridTextColumn() { MappingName = "OrderID" };

            var column1 = new GridTemplateColumn()
            {
                MappingName = "CustomerID",
                CellTemplate = new DataTemplate(typeof(ButtonClass)),
                HeaderTemplate = new DataTemplate(typeof(HeaderTemplate))
            };

            var column3 = new GridTextColumn() { MappingName = "Freight"};
            var column4 = new GridTextColumn() { MappingName = "Country" };


            sfGrid.Columns.Add(column2);
            sfGrid.Columns.Add(column1);
            sfGrid.Columns.Add(column3);
            sfGrid.Columns.Add(column4);
            sfGrid.HeightRequest = 1200;

            Button btn = new Button();
            btn.Text = "Click";
            btn.Clicked += Btn_Clicked;

            layout = new StackLayout() { Children = { sfGrid,btn } };

            MainPage = new ContentPage() { Content  = layout };

        }

        private void Btn_Clicked(object sender, EventArgs e)
        {
            //  Can able to display TemplateColumn by removing already existed TextColumn and 
            //  insert the new template column at that index.

            //sfGrid.Columns.RemoveAt(1);
            //sfGrid.Columns.Insert(1,new GridTemplateColumn()
            //{
            //    MappingName = "CustomerID",
            //    CellTemplate = new DataTemplate(typeof(ButtonClass))
            //});
        }
    }
}
